#===============================================================================
# General Settings
#===============================================================================
# Terrain tags for the differents phenomenos
GRASSTERRAINTAG = 2 # Essential's default is 2
WATERTERRAINTAG = 7 # Essential's default is 7
CAVETERRAINTAG  = 4 # Essential's default is 4

# Chance to make a phenomeno appear, lower chance = more probability 
# to make a phenomeno appear. Do not touch if you don't know why.
PHENOMENOCHANCE = 12

#===============================================================================
# Map Setting
# * How to add a new encounter
# - Copy and paste this after the last encounters info 
#   modifying the things you need
# - This works like the Encounters from Essentials so
#   never delete a Pokemon/Item row! **IMPORTANT**
# ** Tips
# -- You can delete a full section, just delete everything between
#    ***START SECTION*** and ***END SECTION***
# -- If you delete the full section for Pokémon in caves you will
#    only find items and vice versa.
=begin

ENCOUNTERS.push(
[MAPID, # ***MAP ID***
[ # GRASS 
#***START SECTION***
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
#***END SECTION***
],
[ # SURF
#***START SECTION***
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
#***END SECTION***
],
[[# CAVE POKES
#***START SECTION***
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
#***END SECTION***
],
[ # CAVE ITEMS
#***START SECTION***
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # NORMAL
[:ITEMNAME],      # RARE
[:ITEMNAME],      # RARE
[:ITEMNAME],      # RARE
[:ITEMNAME],      # RARE
[:ITEMNAME],      # VERY RARE
[:ITEMNAME],      # VERY RARE
[:ITEMNAME],      # VERY RARE
[:ITEMNAME],      # VERY RARE
[:ITEMNAME],      # VERY RARE
#***END SECTION***
]],
[ # FISHING
#***START SECTION***
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 20%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     # 10%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #  5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
[:POKE, MIN LEVEL, MAX LEVEL],     #2.5%
#***END SECTION***
],
])

=end
#===============================================================================
ENCOUNTERS=[]

#===============================================================================
# Game player edit
# Random phenomenos creation
#===============================================================================
class Game_Character
  alias phenomeno_old_increase increase_steps
    
  def increase_steps
    if self == $game_player
      @stepstocalcule=10+rand(20) if !@stepstocalcule
      @stepstocalcule-=1
      if !$game_map.phenoWorking && @stepstocalcule==0
        makePheno=(rand(4096)/PHENOMENOCHANCE)>=256
        if makePheno
          $scene.spriteset.createPhenomeno
        end
      end
      @stepstocalcule=10+rand(20) if @stepstocalcule<=0
    end
    phenomeno_old_increase
  end
end

#===============================================================================
# Spriteset Map edit
# This will create the animation needed for phenomenos in the map
#===============================================================================
class Game_Map
  attr_accessor :phenoWorking
  attr_accessor :battlePheno
  attr_accessor :battlePhenoFishing
  attr_accessor :phenoPosition
  attr_accessor :phenoEventId
  
  def phenoEventId
    @phenoEventId=nil if !@phenoEventId
    return @phenoEventId
  end
  
  def phenoPosition
    @phenoPosition=[0,0] if !@phenoPosition
    return @phenoPosition
  end
  
  def canBattlePheno?
    return battlePheno && !$PokemonGlobal.fishing
  end
  
  def battlePhenoFishing
    @battlePhenoFishing = false if !@battlePhenoFishing
    return @battlePhenoFishing
  end
  
  def battlePheno
    @battlePheno = false if !@battlePheno
    return @battlePheno
  end
  
  def phenoWorking
    @phenoWorking = false if !@phenoWorking
    return @phenoWorking
  end
  
  alias pheno_old_setup setup
  def setup(map_id)
    pheno_old_setup(map_id)
  end
end

#===============================================================================
# Spriteset Map edit
# This will create the animation needed for phenomenos in the map
#===============================================================================
class Spriteset_Map
  attr_accessor :phenosprites
  attr_accessor :character_sprites
  
  alias pheno_old_initialize initialize
  def initialize(map=nil)
    pheno_old_initialize(map)
    @phenosprites=[]
  end
  
  def createPhenomeno
    pheno=PhenoAnimation.new
  end
  
  def disposePhenosprites
    if @phenosprites!=nil
      for sprite in @phenosprites
        sprite.dispose
      end
    end
    @phenosprites.clear
  end
  
  alias pheno_old_dispose dispose
  def dispose
    pheno_old_dispose
    disposePhenosprites
  end
  
  alias pheno_old_update update
  def update
    pheno_old_update
    if @phenosprites!=nil
      for sprite in @phenosprites
       sprite.update 
      end
    end
  end
end
#===============================================================================
# PhenoAnimation class
# Create the animation
#===============================================================================
class PhenoAnimation
  def initialize
    return if !$scene || !$scene.is_a?(Scene_Map) 
    viewport=$scene.spriteset.viewport1
    phenosprites=$scene.spriteset.phenosprites
    character_sprites=$scene.spriteset.character_sprites
    nid=getNewId
    fev=$game_map.events[nid]
    grassPositions=[]
    waterPositions=[]
    cavePositions=[]
    position=false
    posibles=[false,false,false]
    
    for i in 0...ENCOUNTERS.length
      encounterInfo=ENCOUNTERS[i] if ENCOUNTERS[i][0]==$game_map.map_id
    end
    
    return if !encounterInfo
    
    # Create the position
    for x in 0...$game_map.width
      for y in 0...$game_map.height
        terrain=$game_map.terrain_tag(x,y)
        if terrain==GRASSTERRAINTAG && encounterInfo[1].length>0 # Grass
          posibles[0]=true
          grassPositions.push([x,y])
        elsif terrain==WATERTERRAINTAG && encounterInfo[2].length>0 # Water
          posibles[1]=true
          waterPositions.push([x,y])
        elsif terrain==CAVETERRAINTAG && 
          (encounterInfo[3][0].length>0 || encounterInfo[3][1].length>0) # Cave
          posibles[2]=true
          cavePositions.push([x,y])
        end
      end
    end
    
    return if getTrues(posibles)==0
    type=rand(3)
    while !position
      case type
      when 0 # Grass
        type=rand(3) if !posibles[0]
        position=grassPositions[rand(grassPositions.length)]
      when 1 # Water
        type=rand(3) if !posibles[1]
        position=waterPositions[rand(waterPositions.length)]
      when 2 # Cave
        type=rand(3) if !posibles[2]
        position=cavePositions[rand(cavePositions.length)]
      end
    end
    rpgEvent=RPG::Event.new(position[0],position[1])
    rpgEvent.id=nid       
    fev=Game_Event.new($game_map.map_id,convertToPhenoEvent(rpgEvent,type,encounterInfo),$game_map)
    $game_map.events[nid]=fev
    eventsprite=Sprite_Character.new(viewport,fev)
    character_sprites.push(eventsprite)
    phenosprites.push(PhenoSprite.new(eventsprite,fev,viewport,
    $game_map,nid,character_sprites,type))
    $game_map.phenoPosition=[position[0],position[1]]
    $game_map.phenoEventId=nid
    $game_map.phenoWorking=true
  end
  
  def getTrues(bool)
    ret=0
    for i in 0...bool.length
      ret+=1 if bool[i]==true
    end
    return ret
  end
  
  def convertToPhenoEvent(event,type,encounterInfo)
  return nil if !event || event.pages.length==0
    ret=RPG::Event.new(event.x,event.y)
    name=event.name
    ret.name=event.name
    ret.id=event.id
    ret.pages=[]
    ret.name="Phenomeno"
    isItem = false
    
    if type==2 # Random item or poke for caves
      isItem=rand(100)>30
      if encounterInfo[3][1].length<=0 # No items
        isItem=false
      elsif encounterInfo[3][0].length<=0 # No pokes
        isItem=true
      end
    end
    
    # Get random poke
    chances=isItem ? [5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,2.5,2.5,2.5,1,1,1,1,1] : 
    [20,20,20,10,10,5,5,5,2.5,2.5]
    chancetotal=0
    chances.each {|a| chancetotal+=a}
    rnd=0
    1.times do
      r=rand(chancetotal)
      rnd=r if rnd<r
    end
    chosenpkmn=0
    chance=0
    for i in 0...chances.length
      chance+=chances[i]
      if rnd<chance
        chosenpkmn=i
        break
      end
    end

    if type!=2 # Cave
      pokeinfo=encounterInfo[type+1][chosenpkmn]
    elsif type==2
      if isItem
        pokeinfo=encounterInfo[type+1][1][chosenpkmn]
      else
        pokeinfo=encounterInfo[type+1][0][chosenpkmn]
      end
    end
    
    level=pokeinfo[1]+rand(1+pokeinfo[2]-pokeinfo[1]) if !isItem
    poke=pokeinfo[0]
    if !poke.is_a?(Numeric)
      if isItem
        poke=getID(PBItems,poke)
      else
        poke=getID(PBSpecies,poke)
      end
    end
       
    # Event page 1
    page=RPG::Event::Page.new
    page.trigger=4
    page.list=[]
    pbPushBranch(page.list,
     sprintf("$game_map.canBattlePheno?"),1)
    if isItem
    pbPushScript(page.list,
       sprintf("Kernel.pbReceiveItem(#{poke})"))
       else
    pbPushScript(page.list,
       sprintf("pbWildBattle(#{poke},#{level})"))
    end
    pbPushScript(page.list,
       sprintf("pbErasePhenomeno"))
    pbPushElse(page.list,1)
    pbPushBranchEnd(page.list,1)
    pbPushEnd(page.list)
    ret.pages.push(page)
    return ret
  end

  def getNewId
    newId = 1
    while $game_map.events[newId] != nil do
      break if $game_map.events[newId].name=="Phenomeno"
      newId += 1
    end
    return newId
  end
end

def pbErasePhenomeno(eventid=nil)
  return if !$game_map.phenoWorking
  eventid=get_character(0).id if eventid==nil
  $game_map.events[eventid].erase
  $scene.spriteset.disposePhenosprites
  $game_map.phenoWorking=false
  $game_map.battlePheno=false
  $game_map.battlePhenoFishing=false
  $game_map.phenoPosition=[0,0]
  $game_map.phenoEventId=nil
end

#===============================================================================
# PhenoAnimation class
# Create the animation
#===============================================================================
class PhenoSprite
  def initialize(sprite,event,viewport,map,nid,chardata,type)
    @frame = 0
    @frames = 4
    @currentIndex = 0
    @type=type
    case type
    when 0
      @bitmapFile=BitmapCache.load_bitmap("Graphics/Pictures/grassPheno")
    when 1
      @bitmapFile=BitmapCache.load_bitmap("Graphics/Pictures/waterPheno")
    when 2
      @bitmapFile=BitmapCache.load_bitmap("Graphics/Pictures/cavePheno")
    end
    @bitmap=Bitmap.new(@bitmapFile.width,@bitmapFile.height)
    @bitmap.blt(0,0,@bitmapFile,Rect.new(0,0,@bitmapFile.width,@bitmapFile.height))
    @width=@bitmap.height*2
    @height=@bitmap.height*2
    @totalFrames=@bitmap.width/@bitmap.height
    @animationFrames=@totalFrames*@frames
    @loop_points=[0,@totalFrames]    
    @actualBitmap=Bitmap.new(@width,@height)
    @actualBitmap.clear
    @actualBitmap.stretch_blt(Rect.new(0,0,@width,@height),@bitmap,Rect.new(@currentIndex*(@width/2),0,@width/2,@height/2))
    @rsprite=sprite
    @sprite=Sprite.new(viewport)
    @sprite.bitmap=@actualBitmap
    @opacity=255
    @realwidth=@sprite.bitmap.width/4
    @sprite.opacity=@opacity
    @event=event
    @disposed=false
    @map=map
    @eventid=nid
    @viewport=viewport
    @chardata=chardata
    pbDayNightTint(@sprite)
    update
  end

  def dispose
    if !@disposed
     @disposed=true
     for i in 0...@chardata.length
       @chardata.delete_at(i) if @chardata[i]==@rsprite
     end
     @rsprite.dispose
     @sprite.dispose 
     @sprite=nil
    end
  end
 
  def updateAnimation
    @frames=4
    @frame+=1
    if @frame >=@frames
      @currentIndex+=1
      @currentIndex=@loop_points[0] if @currentIndex >=@loop_points[1]
      @currentIndex=@loop_points[1]-1 if @currentIndex < @loop_points[0]
      @frame=0
    end
    @actualBitmap.clear
    @actualBitmap.stretch_blt(Rect.new(0,0,@width,@height),@bitmap,Rect.new(@currentIndex*(@width/2),0,@width/2,@height/2))
    @sprite.bitmap=@actualBitmap
  end
      
  def update 
    return if @disposed 
    updateAnimation
    x=@rsprite.x-@rsprite.ox
    y=@rsprite.y-@rsprite.oy
    width=@rsprite.src_rect.width
    height=@rsprite.src_rect.height
    $game_map.battlePheno=true if @event.x == $game_player.x && @event.y==$game_player.y && 
      @event.map==$game_player.map
    @sprite.x=x+width/2
    @sprite.y=y+height
    @sprite.ox=@width/2
    @sprite.oy=@sprite.bitmap.height
    @sprite.z=@rsprite.z
  end
end
#===============================================================================
# Modify encounter method for delete phenomenos if you enter a battle
#===============================================================================
Events.onEndBattle+=proc {|sender,e|
   decision=e[0]
   pbErasePhenomeno($game_map.phenoEventId) 
}

#===============================================================================
# Modify fishing method
#===============================================================================

def pbFishing(hasencounter,rodtype=1)
  bitechance=20+(25*rodtype)   # 45, 70, 95
  if $Trainer.party.length>0 && !$Trainer.party[0].isEgg?
    bitechance*=2 if isConst?($Trainer.party[0].ability,PBAbilities,:STICKYHOLD)
    bitechance*=2 if isConst?($Trainer.party[0].ability,PBAbilities,:SUCTIONCUPS)
  end
  
  xbehind=($game_player.direction==4) ? $game_player.x-1 : ($game_player.direction==6) ? $game_player.x+1 : $game_player.x
  ybehind=($game_player.direction==8) ? $game_player.y-1 : ($game_player.direction==2) ? $game_player.y+1 : $game_player.y

  if $game_map.phenoPosition==[xbehind,ybehind] && $game_map.phenoWorking
    bitechance=100
    hasencounter=true
    $game_map.battlePhenoFishing=true
  end
  
  hookchance=100
  hasencounter=true
  oldpattern=$game_player.fullPattern
  pbFishingBegin
  msgwindow=Kernel.pbCreateMessageWindow
  loop do
    time=2+rand(10)
    message=""
    time.times do 
      message+=".  "
    end
    if pbWaitMessage(msgwindow,time)
      pbFishingEnd
      $game_player.setDefaultCharName(nil,oldpattern)
      Kernel.pbMessageDisplay(msgwindow,_INTL("Parece que no pican..."))
      Kernel.pbDisposeMessageWindow(msgwindow)
      return false
    end
    if rand(100)<bitechance && hasencounter
      frames=rand(21)+20
      if !pbWaitForInput(msgwindow,message+_INTL("\r\n¡Oh!  ¡Han picado!"),frames)
        pbFishingEnd
        $game_player.setDefaultCharName(nil,oldpattern)
        Kernel.pbMessageDisplay(msgwindow,_INTL("El Pokémon ha huido..."))
        Kernel.pbDisposeMessageWindow(msgwindow)
        return false
      end
      if rand(100)<hookchance || FISHINGAUTOHOOK
        Kernel.pbMessageDisplay(msgwindow,_INTL("¡Has pescado un Pokémon!"))
        Kernel.pbDisposeMessageWindow(msgwindow)
        pbFishingEnd
        $game_player.setDefaultCharName(nil,oldpattern)
        return true
      end
#      bitechance+=15
#      hookchance+=15
    else
      pbFishingEnd
      $game_player.setDefaultCharName(nil,oldpattern)
      Kernel.pbMessageDisplay(msgwindow,_INTL("Parece que no pican..."))
      Kernel.pbDisposeMessageWindow(msgwindow)
      return false
    end
  end
  
  Kernel.pbDisposeMessageWindow(msgwindow)
  return false
end


class PokemonEncounters
  def pbEncounteredPokemon(enctype,tries=1)
    if !$game_map.battlePhenoFishing
      if enctype<0 || enctype>EncounterTypes::EnctypeChances.length
        raise ArgumentError.new(_INTL("Encounter type out of range"))
      end
      return nil if @enctypes[enctype]==nil
      chances=EncounterTypes::EnctypeChances[enctype]
      chancetotal=0
      chances.each {|a| chancetotal+=a}
      rnd=0
      tries.times do
        r=rand(chancetotal)
        rnd=r if rnd<r
      end
      chosenpkmn=0
      chance=0
      for i in 0...chances.length
        chance+=chances[i]
        if rnd<chance
          chosenpkmn=i
          break
        end
      end
      encounter=@enctypes[enctype][chosenpkmn]
      return nil if !encounter
      level=encounter[1]+rand(1+encounter[2]-encounter[1])
      return [encounter[0],level]
      
    else # Fishing in a phenomeno
      
    for i in 0...ENCOUNTERS.length
      encounterInfo=ENCOUNTERS[i] if ENCOUNTERS[i][0]==$game_map.map_id
    end
    
    chances=[20,20,20,10,10,5,5,5,2.5,2.5]
    chancetotal=0
    chances.each {|a| chancetotal+=a}
    rnd=0
    1.times do
      r=rand(chancetotal)
      rnd=r if rnd<r
    end
    chosenpkmn=0
    chance=0
    for i in 0...chances.length
      chance+=chances[i]
      if rnd<chance
        chosenpkmn=i
        break
      end
    end
    
    if(encounterInfo[4].length>0) # Check if there are fishing pokes
      pokeinfo=encounterInfo[4][chosenpkmn]
    else # If there's not fishing pokes in the actual map, use the surf ones
      pokeinfo=encounterInfo[2][chosenpkmn]
    end
  
    level=pokeinfo[1]+rand(1+pokeinfo[2]-pokeinfo[1])
    poke=pokeinfo[0]
    if !poke.is_a?(Numeric)
      poke=getID(PBSpecies,poke)
    end
    return [poke, level]
    end
  end
end


ItemHandlers::UseInField.add(:OLDROD,proc{|item|
   terrain=Kernel.pbFacingTerrainTag
   notCliff=$game_map.passable?($game_player.x,$game_player.y,$game_player.direction)
   if !pbIsWaterTag?(terrain) || (!notCliff && !$PokemonGlobal.surfing)
     Kernel.pbMessage(_INTL("No puedes usar eso aquí."))
     next
   end
   encounter=$PokemonEncounters.hasEncounter?(EncounterTypes::OldRod)
   if pbFishing(encounter,1)
     pbEncounter(EncounterTypes::OldRod)
   end
   pbErasePhenomeno($game_map.phenoEventId)
})

ItemHandlers::UseInField.add(:GOODROD,proc{|item|
   terrain=Kernel.pbFacingTerrainTag
   notCliff=$game_map.passable?($game_player.x,$game_player.y,$game_player.direction)
   if !pbIsWaterTag?(terrain) || (!notCliff && !$PokemonGlobal.surfing)
     Kernel.pbMessage(_INTL("No puedes usar eso aquí."))
     next
   end
   encounter=$PokemonEncounters.hasEncounter?(EncounterTypes::GoodRod)
   if pbFishing(encounter,2)
     pbEncounter(EncounterTypes::GoodRod)
   end
   pbErasePhenomeno($game_map.phenoEventId)
})

ItemHandlers::UseInField.add(:SUPERROD,proc{|item|
   terrain=Kernel.pbFacingTerrainTag
   notCliff=$game_map.passable?($game_player.x,$game_player.y,$game_player.direction)
   if !pbIsWaterTag?(terrain) || (!notCliff && !$PokemonGlobal.surfing)
     Kernel.pbMessage(_INTL("No puedes usar eso aquí."))
     next
   end
   encounter=$PokemonEncounters.hasEncounter?(EncounterTypes::SuperRod)
   if pbFishing(encounter,3)
     pbEncounter(EncounterTypes::SuperRod)
   end
   pbErasePhenomeno($game_map.phenoEventId)
})